/*
 * sja1105.c
 *
 * Functions for NXP SJA1105 Ethernet Switch
 *
 * Copyright (C) 2018 NetModule AG - http://www.netmodule.com/
 *
 * SPDX-License-Identifier:	GPL-2.0+
 */

#include <common.h>
#include <errno.h>
#include <spi.h>

#include "sja1105.h"


#define SJA_OPCODE_WRITE	0x80
#define SJA_OPCODE_READ		0x00
#define SJA_READ_CNT(x)		(((x) & 0x3F) << 1)



static struct spi_slave *sja1105_spi_bus = 0;
static int bus_claimed = 0;


void sja1105_init(struct spi_slave *spi)
{
	sja1105_spi_bus = spi;
}

void sja1105_claim_bus(void)
{
	spi_claim_bus(sja1105_spi_bus);

	bus_claimed++;
}

void sja1105_release_bus(void)
{
	spi_release_bus(sja1105_spi_bus);

	bus_claimed--;
}

uint32_t sja1105_read_reg(uint32_t address)
{
	uint32_t return_value;
	uint8_t dataspi[8];
	uint8_t datain[8];

	/* OPCODE: READ, READ CNT = 1, address from bit 24 DOWNTO bit 4 */

	dataspi[0] = (SJA_OPCODE_READ | SJA_READ_CNT(1)) | ((address >> 20) & 0x01); /* MSB */
	dataspi[1] = (address >> 12) & 0xFF;
	dataspi[2] = (address >> 4) & 0xFF;
	dataspi[3] = (address << 4) & 0xF0;

	dataspi[4] = 0x00; /* ignored by slave, use to readout the register */
	dataspi[5] = 0x00;
	dataspi[6] = 0x00;
	dataspi[7] = 0x00;

	(void)spi_xfer(sja1105_spi_bus, 8*sizeof(dataspi) /*bitlen*/, dataspi, datain /*din*/, SPI_XFER_BEGIN | SPI_XFER_END /*flags*/);

	return_value = (datain[4]<<24) | (datain[5]<<16) | (datain[6]<<8) | (datain[7]<<0);

	return return_value;
}

void sja1105_write_reg(uint32_t address, uint32_t data)
{
	uint8_t dataspi[8];

	/* OPCODE: WRITE, address from bit 24 DOWNTO bit 4 */

	dataspi[0] = SJA_OPCODE_WRITE | (address >> 20 & 0x01);
	dataspi[1] = (address >> 12) & 0xFF;/* */
	dataspi[2] = (address >> 4) & 0xFF;
	dataspi[3] = (address << 4) & 0xF0;

	dataspi[4] = (data >> 24) & 0xFF;
	dataspi[5] = (data >> 16) & 0xFF;
	dataspi[6] = (data >> 8) & 0xFF;
	dataspi[7] = data & 0xFF;

	(void)spi_xfer(sja1105_spi_bus, 8*sizeof(dataspi) /*bitlen*/, dataspi, NULL /*din*/, SPI_XFER_BEGIN| SPI_XFER_END /*flags*/);
}

void sja1105_configure_firmware(void)
{
    static const uint8_t config_data_0[] = { 0x80, 0x20, 0x00, 0x00, 0x9E, 0x00, 0x03, 0x0E, 0x06, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x50, 0x21, 0x6F, 0x25, 0x6B, 0xFE, 0xF9, 0x00, 0x00, 0x03, 0xFF, 0xFF, 0xFF, 0xFE, 0xF9, 0x00, 0x00, 0x03, 0xFF, 0xFF, 0xFF, 0xFE, 0xF9, 0x00, 0x00, 0x03, 0xFF, 0xFF, 0xFF, 0xFE, 0xF9, 0x00, 0x00, 0x03, 0xFF, 0xFF, 0xFF, 0xFE, 0xF9, 0x00, 0x00, 0x03, 0xFF, 0xFF, 0xFF, 0xFE, 0xF9, 0x00, 0x00, 0x03, 0xFF, 0xFF, 0xFF, 0xFE, 0xF9, 0x00, 0x00, 0x03, 0xFF, 0xFF, 0xFF, 0xFE, 0xF9, 0x00, 0x00, 0x03, 0xFF, 0xFF, 0xFF, 0xFE, 0xF9, 0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFE, 0xF9, 0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFE, 0xF9, 0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFE, 0xF9, 0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFE, 0xF9, 0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFE, 0xF9, 0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFE, 0xF9, 0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFE, 0xF9, 0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFE, 0xF9, 0x00, 0x00, 0x0B, 0xFF, 0xFF, 0xFF, 0xFE, 0xF9, 0x00, 0x00, 0x0B, 0xFF, 0xFF, 0xFF, 0xFE, 0xF9, 0x00, 0x00, 0x0B, 0xFF, 0xFF, 0xFF, 0xFE, 0xF9, 0x00, 0x00, 0x0B, 0xFF, 0xFF, 0xFF, 0xFE, 0xF9, 0x00, 0x00, 0x0B, 0xFF, 0xFF, 0xFF, 0xFE, 0xF9, 0x00, 0x00, 0x0B, 0xFF, 0xFF, 0xFF, 0xFE, 0xF9, 0x00, 0x00, 0x0B, 0xFF, 0xFF, 0xFF, 0xFE, 0xF9, 0x00, 0x00, 0x0B, 0xFF, 0xFF, 0xFF, 0xFE, 0xF9, 0x00, 0x00, 0x0F, 0xFF, 0xFF, 0xFF, 0xFE, 0xF9, 0x00, 0x00, 0x0F, 0xFF, 0xFF, 0xFF, 0xFE, 0xF9, 0x00, 0x00, 0x0F, 0xFF, 0xFF, 0xFF, 0xFE, 0xF9, 0x00, 0x00, 0x0F, 0xFF, 0xFF, 0xFF, 0xFE, 0xF9, 0x00, 0x00, 0x0F, 0xFF, 0xFF, 0xFF, 0xFE, 0xF9, 0x00, 0x00, 0x0F, 0xFF, 0xFF, 0xFF };
    static const uint8_t config_data_1[] = { 0x80, 0x20, 0x04, 0x00, 0xFE, 0xF9, 0x00, 0x00, 0x0F, 0xFF, 0xFF, 0xFF, 0xFE, 0xF9, 0x00, 0x00, 0x0F, 0xFF, 0xFF, 0xFF, 0xFE, 0xF9, 0x00, 0x00, 0x13, 0xFF, 0xFF, 0xFF, 0xFE, 0xF9, 0x00, 0x00, 0x13, 0xFF, 0xFF, 0xFF, 0xFE, 0xF9, 0x00, 0x00, 0x13, 0xFF, 0xFF, 0xFF, 0xFE, 0xF9, 0x00, 0x00, 0x13, 0xFF, 0xFF, 0xFF, 0xFE, 0xF9, 0x00, 0x00, 0x13, 0xFF, 0xFF, 0xFF, 0xFE, 0xF9, 0x00, 0x00, 0x13, 0xFF, 0xFF, 0xFF, 0xFE, 0xF9, 0x00, 0x00, 0x13, 0xFF, 0xFF, 0xFF, 0xFE, 0xF9, 0x00, 0x00, 0x13, 0xFF, 0xFF, 0xFF, 0x03, 0x68, 0x8B, 0xEA, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x7D, 0x0B, 0xCB, 0xF2, 0xF8, 0x00, 0x00, 0x00, 0x00, 0x31, 0x80, 0x7F, 0x09, 0x52, 0x68, 0x0D, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1A, 0x6A, 0xF6, 0x23, 0x53, 0x10, 0x00, 0x00, 0x00, 0xF7, 0xBD, 0xF5, 0x8D, 0x10, 0x00, 0x00, 0x00, 0xEF, 0x7B, 0xF5, 0x8D, 0x10, 0x00, 0x00, 0x00, 0xDE, 0xF7, 0xF5, 0x8D, 0x10, 0x00, 0x00, 0x00, 0xBD, 0xEF, 0xF5, 0x8D, 0x10, 0x00, 0x00, 0x00, 0x7B, 0xDF, 0xF5, 0x8D, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0x04, 0xA6, 0x06, 0x09, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x23, 0xDA, 0xB5, 0xBD, 0xC8, 0x00, 0x3F, 0xFC, 0x08, 0x00, 0x00, 0x00, 0x00, 0x07, 0xFC, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00 };
    static const uint8_t config_data_2[] = { 0x80, 0x20, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3F, 0xFC, 0x08, 0x00, 0x00, 0x00, 0x00, 0x07, 0xFC, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3F, 0xFC, 0x08, 0x00, 0x00, 0x00, 0x00, 0x07, 0xFC, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3F, 0xFC, 0x0E, 0x00, 0x00, 0x00, 0x00, 0x07, 0xFC, 0x01, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3F, 0xFC, 0x0E, 0x00, 0x00, 0x00, 0x00, 0x07, 0xFC, 0x01, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x83, 0x75, 0xF9, 0x8D, 0x0D, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x25, 0x0E, 0x7C, 0xBD, 0x00, 0x01, 0x25, 0xC0, 0x70, 0x94, 0x84, 0x50, 0x0E, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0xC8, 0xA7, 0xCE, 0xE6, 0x00, 0x71, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC3, 0xF7, 0x04, 0xB9, 0x11, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0A, 0x57, 0x1F, 0x81, 0x3F, 0x06, 0x44, 0x00, 0x00, 0x00, 0x00, 0x04, 0x08, 0x00, 0x00, 0x00, 0x00, 0xFF, 0x0D, 0xB0, 0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x58, 0x00, 0x00, 0x00, 0x5A, 0x9C, 0x37, 0x20, 0x4E, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x3A, 0x5D, 0x5E, 0x24, 0xA4, 0x9A, 0x00, 0x00, 0x7B, 0x51, 0xDA, 0x7D, 0x00, 0x00, 0x00, 0x00 };
    static const uint8_t config_data_3[] = { 0x80, 0x20, 0x0C, 0x00, 0x00, 0x00, 0x00, 0x00, 0x37, 0x6E, 0x02, 0x8B };

	uint32_t val;
	int rc;

	rc = spi_xfer(sja1105_spi_bus, 8*sizeof(config_data_0) /*bitlen*/, config_data_0, NULL, SPI_XFER_BEGIN | SPI_XFER_END /*flags*/);
	if (rc != 0)
		printf ("spi_xfer fail for config data 0\n");

	rc = spi_xfer(sja1105_spi_bus, 8*sizeof(config_data_1) /*bitlen*/, config_data_1, NULL, SPI_XFER_BEGIN | SPI_XFER_END /*flags*/);
	if (rc != 0)
		printf ("spi_xfer fail for config data 1\n");

	rc = spi_xfer(sja1105_spi_bus, 8*sizeof(config_data_2) /*bitlen*/, config_data_2, NULL, SPI_XFER_BEGIN | SPI_XFER_END /*flags*/);
	if (rc != 0)
		printf ("spi_xfer fail for config data 2\n");

	rc = spi_xfer(sja1105_spi_bus, 8*sizeof(config_data_3) /*bitlen*/, config_data_3, NULL, SPI_XFER_BEGIN | SPI_XFER_END /*flags*/);
	if (rc != 0)
		printf ("spi_xfer fail for config data 3\n");

	/* Check that config was properly loaded */
	val = sja1105_read_reg(SJA_REG_CONFIG_STATUS);
	if ((val & 0x80000000) != 0x80000000) { // TODO: Define bitmask
		printf("ERROR: Switch configuration load failed\n");

		// TODO: provide return code.
	}
}

void sja1105_configure_mode_and_clocks(void)
{
	sja1105_write_reg( 0x10000A, 0x0A010141);	/* PLL 1 setup for 50MHz */
	sja1105_write_reg( 0x10000A, 0x0A010940);	/* PLL 1 setup for 50MHz */

	/* Port 0:  RMII (PHY mode = external REFCLK) */
	sja1105_write_reg( 0x10000B, 0x0A000001);	// Disable IDIV0
	sja1105_write_reg( 0x100015, 0x00000800);	// CLKSRC of RMII_REF_CLK_0 = TX_CLK_0

	/* Port 1: RMII (MAC mode) */
	sja1105_write_reg( 0x10000C, 0x0A000001);	// Disable IDIV1
	sja1105_write_reg( 0x10001C, 0x02000800);	// CLKSRC of RMII_REF_CLK_1 = TX_CLK_1
	sja1105_write_reg( 0x10001F, 0x0E000800);	// CLKSRC of EXT_TX_CLK1 = PLL1 (50 MHz)

	/* Port 2: RMII (MAC mode) */
	sja1105_write_reg( 0x10000D, 0x0A000001);	// Disable IDIV2
	sja1105_write_reg( 0x100023, 0x04000800);	// CLKSRC of RMII_REF_CLK_2 = TX_CLK_2
	sja1105_write_reg( 0x100026, 0x0E000800);	// CLKSRC of EXT_TX_CLK2 = PLL1 (50 MHz)

	/* Port 3: RMII (MAC mode) */
	sja1105_write_reg( 0x10000E, 0x0A000001);	// Disable IDIV3
	sja1105_write_reg( 0x10002A, 0x06000800);	// CLKSRC of RMII_REF_CLK_3 = TX_CLK_3
	sja1105_write_reg( 0x10002D, 0x0E000800);	// CLKSRC of EXT_TX_CLK3 = PLL1 (50 MHz)

	/* Port 4: RMII (PHY mode = external REFCLK) */
	sja1105_write_reg( 0x10000F, 0x0A000001);	// Disable IDIV4
	sja1105_write_reg( 0x100031, 0x08000800);	// CLKSRC of RMII_REF_CLK_4 = TX_CLK_4
}

void sja1105_configure_io(void)
{
	/* Port 0 and Port 4 RX */
	/* Enable pull down on CPU Port RX_DV/CRS_DV/RX_CTL and RX_ER and RX_CLK/RXC and RXD2 RXD3 */
	sja1105_write_reg(0x100801, 0x03020313);
	sja1105_write_reg(0x100809, 0x03020313);

	/* Port 1 to Port 3 RX */
	/* Enable pull down on CPU Port ... and RX_CLK/RXC and RXD2 RXD3 */
	// TODO: What is ...
	sja1105_write_reg(0x100803, 0x03020213);
	sja1105_write_reg(0x100805, 0x03020213);
	sja1105_write_reg(0x100807, 0x03020213);

	/* Port 0 to Port 4 TX */
	/* Enable pull down on CPU Port TX_ER and TXD2 TXD3 */
	sja1105_write_reg(0x100800, 0x13121312);
	sja1105_write_reg(0x100802, 0x13121312);
	sja1105_write_reg(0x100804, 0x13121312);
	sja1105_write_reg(0x100806, 0x13121312);
	sja1105_write_reg(0x100808, 0x13121312);
}

#if 0
/*
 * readout and print the configured IO pads (unused IOs)
 */
static void sja1105_read_io(void)
{
	uint32_t val;

	val = sja1105_read_reg(0x100801);
	printf("CFG_PAD_MII0_RX Reg: %08x\n", val);
	val = sja1105_read_reg(0x100800);
	printf("CFG_PAD_MII0_TX Reg: %08x\n", val);

	val = sja1105_read_reg(0x100803);
	printf("CFG_PAD_MII1_RX Reg: %08x\n", val);
	val = sja1105_read_reg(0x100802);
	printf("CFG_PAD_MII1_TX Reg: %08x\n", val);

	val = sja1105_read_reg(0x100805);
	printf("CFG_PAD_MII2_RX Reg: %08x\n", val);
	val = sja1105_read_reg(0x100804);
	printf("CFG_PAD_MII2_TX Reg: %08x\n", val);

	val = sja1105_read_reg(0x100807);
	printf("CFG_PAD_MII3_RX Reg: %08x\n", val);
	val = sja1105_read_reg(0x100806);
	printf("CFG_PAD_MII3_TX Reg: %08x\n", val);

	val = sja1105_read_reg(0x100809);
	printf("CFG_PAD_MII4_RX Reg: %08x\n", val);
	val = sja1105_read_reg(0x100808);
	printf("CFG_PAD_MII4_TX Reg: %08x\n", val);
}

#endif

#if !defined(CONFIG_SPL_BUILD)

static int do_sjainfo(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
{
	uint32_t p0_mac_stat;
	uint32_t p0_txf;
	uint32_t p0_rxf;
	uint32_t p1_mac_stat;
	uint32_t p1_txf;
	uint32_t p1_rxf;
	uint32_t p2_mac_stat;
	uint32_t p2_rxf;
	uint32_t p2_txf;
	uint32_t p3_mac_stat;
	uint32_t p3_txf;
	uint32_t p3_rxf;
	uint32_t p4_mac_stat;
	uint32_t p4_rxf;
	uint32_t p4_txf;

	sja1105_claim_bus();

	p0_mac_stat = sja1105_read_reg(0x00200);
	p0_rxf = sja1105_read_reg(0x00406);
	p0_txf = sja1105_read_reg(0x00402);

	p1_mac_stat = sja1105_read_reg(0x00202);
	p1_rxf = sja1105_read_reg(0x00416);
	p1_txf = sja1105_read_reg(0x00412);

	p2_mac_stat = sja1105_read_reg(0x00204);
	p2_rxf = sja1105_read_reg(0x00426);
	p2_txf = sja1105_read_reg(0x00422);

	p3_mac_stat = sja1105_read_reg(0x00206);
	p3_rxf = sja1105_read_reg(0x00436);
	p3_txf = sja1105_read_reg(0x00432);

	p4_mac_stat = sja1105_read_reg(0x00208);
	p4_rxf = sja1105_read_reg(0x00446);
	p4_txf = sja1105_read_reg(0x00442);

	sja1105_release_bus();

	printf("Port            MAC Stat Rx  Tx\n");
	printf("0 (UM)       : %08x %u %u\n", p0_mac_stat, p0_rxf, p0_txf);
	printf("1 (BroadR-0) : %08x %u %u\n", p1_mac_stat, p1_rxf, p1_txf);
	printf("2 (BroadR-1) : %08x %u %u\n", p2_mac_stat, p2_rxf, p2_txf);
	printf("3 (100bTx)   : %08x %u %u\n", p3_mac_stat, p3_rxf, p3_txf);
	printf("4 (CPU)      : %08x %u %u\n", p4_mac_stat, p4_rxf, p4_txf);

	return 0;
}

U_BOOT_CMD(
	sjainfo, 1, 1, do_sjainfo,
	"show eth switch information",
	""
);

#endif
